#! /bin/bash

PACKAGE_NAME=$1

PACKAGE_VERSION="1.0.0"
OPT_PATH=/opt/deepinwine/scanner-drv/$PACKAGE_NAME
CONTAINER_PATH="$HOME/.deepinwine/$PACKAGE_NAME"
WINEBIN="/usr/bin/bisheng"
REGDIR="reg"
FILEDIR="files"

# check container is whether needed to update
echo "check container version ..."
if [ -d "$CONTAINER_PATH" ]; then
    # compare version
    if [ ! -f "$CONTAINER_PATH/VERSION" ] || [ "$(cat "$CONTAINER_PATH/VERSION")" != "$PACKAGE_VERSION" ]; then
        echo "container version is diffrent from current version, update container ..."
        rm -rf "$CONTAINER_PATH"
    else
        exit 0
    fi
fi


# import regs
echo "import regs ..."
if [ -d "$OPT_PATH/$REGDIR" ]; then
    find "$OPT_PATH/$REGDIR" -type f -regex ".*\.reg" | while read file; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "$file"
    done
fi

# copy driver files
echo "copy driver files ..."
if [ -d "$OPT_PATH/$FILEDIR" ]; then
    find "$OPT_PATH/$FILEDIR" -not -type d | while read file; do
        path="$CONTAINER_PATH/drive_c/${file#*$FILEDIR/}"
        dir="${path%/*}"
        mkdir -p "$dir"
        cp -d "$file" "$path"
    done
fi

# register com dlls
echo "register com dlls ..."
if [ -f "$OPT_PATH/$REGDIR/register_dll_list.ini" ]; then
    while read dll_file; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regsvr32 "$dll_file"
    done < "$OPT_PATH/$REGDIR/register_dll_list.ini"
fi

echo "$PACKAGE_VERSION" > "$CONTAINER_PATH/VERSION"

echo "generate container finish !!!"
